#include "Mutex.h"

KMutex::KMutex(string name)
{
	m_MutexName = "MUTEX" + name;
	m_hKeyMutex = NULL;
}

KMutex::~KMutex()
{
	if (m_hKeyMutex) {
		close();
	}
}

bool KMutex::create(string name)
{
	if (name != "") {
		m_MutexName = "MUTEX" + name;
	}
	m_hKeyMutex = CreateMutex(NULL, FALSE, m_MutexName.c_str());
	if (m_hKeyMutex == NULL) {
		printf("CreateMutex(): error: %d.\n", GetLastError());
		return false;
	}
	else {
		printf("CreateMutex(): new %s mutex successfully created.\n", m_MutexName.c_str());
		return true;
	}
}

void KMutex::open(string name)
{
	if (name != "") {
		m_MutexName = "MUTEX" + name;
	}
	m_hKeyMutex = OpenMutex(MUTEX_ALL_ACCESS, FALSE, m_MutexName.c_str());
	if (m_hKeyMutex == NULL) {
		printf("OpenMutex(): error: %d.\n", GetLastError());
	}
	else {
		printf("OpenMutex(): %s mutex successfully opened.\n", m_MutexName.c_str());
	}
}

void KMutex::close()
{
	if (m_hKeyMutex) {
		CloseHandle(m_hKeyMutex);
		m_hKeyMutex = NULL;
	}
}

void KMutex::lock()
{
	WaitForSingleObject(m_hKeyMutex, INFINITE);
}

void KMutex::unlock()
{
	ReleaseMutex(m_hKeyMutex);
}

